"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
// TODO: needs heavy unit testing
function position_at_offset(offset, lines) {
    let line = 0;
    let column = 0;
    for (let text_line of lines) {
        // each line has a new line symbol which is accounted for in offset!
        if (text_line.length + 1 <= offset) {
            offset -= (text_line.length + 1);
            line += 1;
        }
        else {
            column = offset;
            break;
        }
    }
    return { line, column };
}
exports.position_at_offset = position_at_offset;
class RegExpForeignCodeExtractor {
    constructor(options) {
        this.language = options.language;
        this.options = options;
        this.expression = new RegExp(options.pattern);
        this.standalone = this.options.is_standalone;
    }
    extract_foreign_code(code) {
        let match = code.match(this.expression);
        if (match) {
            let host_code;
            if (this.options.keep_in_host === true) {
                host_code = code;
            }
            else if (this.options.keep_in_host === false) {
                host_code = null;
            }
            else {
                host_code = code.replace(this.expression, this.options.keep_in_host);
            }
            let lines = code.split('\n');
            let foreign_code = code.replace(this.expression, this.options.extract_to_foreign);
            // TODO this assumes that the extraction does not modify
            let index = code.indexOf(foreign_code);
            if (index === -1) {
                throw Error('Internal error of RegExpr matcher');
            }
            // TODO???
            index += 1;
            if (position_at_offset(index, lines).line === 0) {
                throw Error();
            }
            return {
                host_code: host_code,
                foreign_code: foreign_code,
                range: {
                    // TODO: this could be slightly optimized (start at start)
                    start: position_at_offset(index, lines),
                    end: position_at_offset(index + match[0].length, lines)
                }
            };
        }
        else {
            return {
                host_code: code,
                foreign_code: null,
                range: null
            };
        }
    }
}
exports.RegExpForeignCodeExtractor = RegExpForeignCodeExtractor;
